const { chain, get } = require('lodash');

const TERM_MAX_WIDTH = process.stdout.columns;

const STATUS_TO_REPRESENTATION = {
  'To Do': { emoji: '⚪', text: 'Todo     ' },
  'In Progress': { emoji: '🔵', text: 'WIP      ' },
  'In review': { emoji: '💛', text: 'In Review' },
  Tested: { emoji: '✅', text: 'Tested   ' },
  Testing: { emoji: '🐛 ', text: 'Testing  ' },
  QA: { emoji: '🐛 ', text: 'QA       ' },
};

const STATUS_TO_SORT_INDEX = chain(STATUS_TO_REPRESENTATION)
  .keys()
  .reduce(
    (acc, key, i) => ({
      ...acc,
      [key]: i,
    }),
    {}
  )
  .value();

const getRepresentationForStatus = (status, useEmojis) =>
  get(
    STATUS_TO_REPRESENTATION,
    `${status}.${useEmojis ? 'emoji' : 'text'}`,
    'Unknown  '
  );

module.exports = {
  TERM_MAX_WIDTH,
  STATUS_TO_REPRESENTATION,
  STATUS_TO_SORT_INDEX,
  getRepresentationForStatus,
};
