const { getMyIssues, selectIssue, selectAction } = require('./utils');
const { loadConfig } = require('./config');
const ACTIONS = require('./actions');

module.exports = async () => {
  const config = await loadConfig();

  console.log(`${config.useEmojis ? '⌛  ' : ''}Fetching your Jira issues...`);

  const { issues, error } = await getMyIssues(config);

  if (error) {
    console.error(error);
    return;
  }

  const issue = await selectIssue({ config, issues });
  const action = await selectAction(issue);

  // Run the action on this issue
  ACTIONS[action](issue, config);
};
